--[[
 Halo 3 & Halo 4 © Microsoft Corporation. Killing Streaks was created under Microsoft's "Game Content Usage Rules" using assets from Halo 3 & Halo 4. It is not endorsed by Microsoft and does not reflect the views or opinions of Microsoft or anyone officially involved in producing or managing Halo 3 and/or Halo 4.  As such, it does not contribute to the official narrative of the fictional universe, if applicable.
 
 Used with permission from Microsoft.
 
 Required Link to Rules:
 http://www.xbox.com/en-US/Community/Developer/Rules
]]

local HKSF = CreateFrame("Frame")

LibStub("AceTimer-3.0"):Embed(HKSF)
LibStub("AceEvent-3.0"):Embed(HKSF)

local killcount = 0
local killstreak = 0
local TimerHandle

function HKSF:StreakEnded()
	if killcount >= 2 then
		print("Timed Killing Streak Ended")
	end
	killcount = 0
end

function CheckKillsPlaySound(killcount, killstreak)
	if killcount > 1 then
		if HKSF:TimeLeft(TimerHandle) > 0 then
			if killcount == 2 then
				-- Double Kill | 2 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				PlaySoundFile(soundfile)
				print("\124cFF79CDCDDouble Kill!")
			elseif killcount == 3 then
				-- Triple Kill | 3 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDTriple Kill!")
				PlaySoundFile(soundfile)
			elseif killcount == 4 then
				-- Overkill | 4 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDOverkill!")
				PlaySoundFile(soundfile)
			elseif killcount == 5 then
				-- Killtacular | 5 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKilltacular!")
				PlaySoundFile(soundfile)
			elseif killcount == 6 then
				-- Killtrocity | 6 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKilltrocity!")
				PlaySoundFile(soundfile)
			elseif killcount == 7 then
				-- Killimanjaro | 7 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKillimanjaro!")
				PlaySoundFile(soundfile)
			elseif killcount == 8 then
				-- Killtastrophe | 8 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKilltastrophe!")
				PlaySoundFile(soundfile)
			elseif killcount == 9 then
				-- Killpocalypse | 9 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKillpocalypse!")
				PlaySoundFile(soundfile)
			elseif killcount == 10 then
				-- Killionaire | 10 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKillionaire!")
				PlaySoundFile(soundfile)
			end
		end
	elseif killstreak > 1 and HKSF:TimeLeft(TimerHandle) > 0 then
		if killstreak == 5 then
			-- Killing Spree | Kill 5 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDKilling Spree!")
			PlaySoundFile(soundfile)
		elseif killstreak == 10 then
			-- Killing Frenzy | Kill 10 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDKilling Frenzy!")
			PlaySoundFile(soundfile)
		elseif killstreak == 15 then
			-- Running Riot | Kill 15 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDRunning Riot!")
			PlaySoundFile(soundfile)
		elseif killstreak == 20 then
			-- Rampage | Kill 20 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDRampage!")
			PlaySoundFile(soundfile)
		elseif killstreak == 25 then
			-- Untouchable | Kill 25 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDUntouchable!")
			PlaySoundFile(soundfile)
		elseif killstreak == 30 then
			-- Invincible | Kill 30 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDInvincible!")
			PlaySoundFile(soundfile)
		elseif killstreak == 35 then
			-- Inconceivable | Kill 35 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDInconceivable!")
			PlaySoundFile(soundfile)
		elseif killstreak == 40 then
			-- Unfriggenbelievable | Kill 40 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDUnfriggenbelievable!")
			PlaySoundFile(soundfile)
		end
	end
end

function HKSF:OnCombatEvent(eventName, timestamp, event, _, sourceGUID, sourceName, _, _, destGUID, destName)
	--print("Event Name:"..eventName.." | Subevent:"..event.." | Killcount:"..killcount.." | Killstreak:"..killstreak)
	-- Debug:
	--[[if event == "PARTY_KILL" then
		print("Dest GUID:"..destGUID..", Source GUID:"..sourceGUID..",Event:"..event..", Player GUID:"..UnitGUID("player"))
	end]]
	if (event == "PARTY_KILL" and sourceGUID == UnitGUID("player")) then
		HKSF:CancelTimer(TimerHandle)
		TimerHandle = HKSF:ScheduleTimer("StreakEnded", 4)
		killcount = killcount + 1
		killstreak = killstreak + 1
		CheckKillsPlaySound(killcount, killstreak)
	elseif (event == "PARTY_KILL" and UnitIsDeadOrGhost("player") == 1) then
		print("Killing Streak Ended")
		killstreak = 0
	end
end

HKSF:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "OnCombatEvent");
--HKSF:SetScript("OnEvent", function(timestamp, event, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)

